> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/annotation/annotation-types/polygonannotation.md).

# Polygon Annotations

Enhance user experience with polygon annotations, allowing creation of closed shapes with customizable fill and stroke colors. Learn how to add points, change border styles, and more using web. The Ap

Polygon annotations are annotations users can draw with multiple points. This can be used to draw any closed shape with lines around content. When initialized, polygons start with no points so they will have to be manually added. The last point in a polygon annotation's path must be the same as the first point to close it out.

Polygon annotations can have both a fill and stroke color. The stroke or border style can also be changed to between a solid, dashed, or cloudy style. The cloud polygon is actually just a polygon annotation with the cloudy style.

![](https://3532544125-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FX9YnTSKIHvV7m0A36LbO%2Fuploads%2Fgit-blob-3e0a1e02e2dcc858e8a113e753f821a8a8697297%2F4ca11210cec47e9db24e5c90902b85c6845a7cfb-274x245.png?alt=media)

While creating the polygon create tool, double-clicking will automatically close the path.

## Instantiation

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { documentViewer, annotationManager, Annotations } = instance.Core;

    documentViewer.addEventListener('annotationsLoaded', () => {
      const annot = new Annotations.PolygonAnnotation({
        PageNumber: 1,
        StrokeColor: new Annotations.Color(0, 255, 0, 1),
      });

      annot.addPathPoint(50, 50);
      annot.addPathPoint(75, 100);
      annot.addPathPoint(100, 50);
      annot.addPathPoint(125, 100);
      annot.addPathPoint(150, 50);
      annot.addPathPoint(50, 50);

      annotationManager.addAnnotation(annot);
      annotationManager.redrawAnnotation(annot);
    });
  });
```

{% endcode %}

[AnnotationManager#annotationsLoaded](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationsLoaded) [PolygonAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html) [PolygonAnnotation.addPathPoint](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#addPathPoint) [Color](https://sdk.apryse.com/api/web/Core.Annotations.Color.html) [AnnotationManager.addAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#addAnnotation) [AnnotationManager.redrawAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#redrawAnnotation)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { docViewer, annotManager, Annotations } = instance;

    docViewer.on('annotationsLoaded', () => {
      const annot = new Annotations.PolygonAnnotation();
      annot.PageNumber = 1;
      annot.StrokeColor = new Annotations.Color(0, 255, 0, 1);

      annot.addPathPoint(50, 50);
      annot.addPathPoint(75, 100);
      annot.addPathPoint(100, 50);
      annot.addPathPoint(125, 100);
      annot.addPathPoint(150, 50);
      annot.addPathPoint(50, 50);

      annotationManager.addAnnotation(annot);
      annotationManager.redrawAnnotation(annot);
    });
  });
```

{% endcode %}

[AnnotationManager#annotationsLoaded](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#event:annotationsLoaded) [PolygonAnnotation](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html) [PolygonAnnotation.addPathPoint](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#addPathPoint) [Color](https://sdk.apryse.com/api/web/Core.Annotations.Color.html) [AnnotationManager.addAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#addAnnotation) [AnnotationManager.redrawAnnotation](https://sdk.apryse.com/api/web/Core.AnnotationManager.html#redrawAnnotation)
{% endtab %}
{% endtabs %}

## XFDF

Element name: `polygon`

{% tabs %}
{% tab title="Shell" %}
{% code lineNumbers="true" %}

```sh
<polygon page="0" rect="49,691,151,743" color="#00FF00" flags="print" name="8830cdbe-3ce0-6365-d549-5c8c49b1f304" subject="Polygon" date="D:20220605160946-07'00'" creationdate="D:20220605160946-07'00'">
  <vertices>50,742;75,692;100,742;125,692;150,742;50,742</vertices>
</polygon>
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Required properties

### PageNumber

Gets or sets the page number of a document that the annotation appears on.

## Notable properties

For the full list of properties, please visit the annotation's [API docs](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html).

### ArcDrawMode

Describes how the arcs of a PolygonCloud annotation will be drawn, can be one of either RANDOM\_ARCS or EQUAL\_ARCS.

{% hint style="info" %}
This property can be set using the **ArcDrawModes** constant on the **PolygonCloudCreateTool**. e.g. **Tools.PolygonCloudCreateTool.ArcDrawModes.EQUAL\_ARCS**
{% endhint %}

### StrokeColor

Gets or sets the color of the annotation's stroke.

### FillColor

Gets or sets the color of the annotation's interior.

### Style

Gets or sets the border style of an annotation. Possible styles include:

* solid
* dash
* cloudy

### StrokeThickness

Gets or sets the width of the annotation's stroke outline.

### Dashes

Gets or sets the border dash style of an annotation. This expects a string representing the length of dashes and spacing inbetween, delimited by commas (ex. `3, 3`). You can specify any amount of lengths but, an odd number of values will be made even by cloning it as a second set. To understand further, you can read more about the [`setLineDash`](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/setLineDash/) API.

### Intensity

Describes intensity of cloudy style effect. Use 0 for no effect.

### Author

The author of the annotation.

### Color

Gets or sets the annotation's stroke color.

### Hidden

Gets or sets whether the annotation is hidden.

### Invisible

Gets or sets whether the annotation is invisible, only if it is an unknown annotation type. Generally for hiding annotations you should use "Hidden".

### IsClickableOutsideRect

Gets or sets whether any parts of the annotation drawn outside of the rect are clickable.

### Listable

Gets or sets whether the annotation should be listed in annotation lists. If set to false, the annotation will also become unselectable.

### Locked

Gets or sets whether the annotation is locked or not. If it's locked it can't be edited or deleted, but the note can be edited.

### LockedContents

Gets or sets whether the annotation contents are locked or not. If the contents are locked then note can't be edited but the annotation can be edited or deleted.

### NoDelete

Gets or sets if this annotation can be deleted.

### NoMove

Gets or sets whether or not the annotation can be moved.

### NoResize

Gets or sets if this annotation can be resized by the user.

### NoRotate

Gets or sets if this annotation can be rotated.

### NoView

Gets or sets whether the annotation is visible on the screen. Differs from Hidden in that it can still be printed if the print flag is set.

### NoZoom

Gets or sets if this annotation scales with the page.

### Printable

Gets or sets whether the annotation should be displayed when printing the page.

### ReadOnly

Gets or sets whether the annotation is readonly or not. If it's readonly both the annotation itself and its note can't be edited or deleted.

### ToggleNoView

Gets or sets whether the ToggleNoView flag is set on the annotation.

## Useful methods

### addPathPoint

When initializing the polygon annotation, you should use the [`addPathPoint`](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#addPathPoint) API to add points the annotation path. The last point should be the same as the first to close out the path.

### getPath

To read the path or points of the polygon annotation, you can use [`getPath`](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#getPath) to get an array of points.

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { documentViewer, annotationManager, Annotations } = instance.Core;

    documentViewer.addEventListener('annotationsLoaded', () => {
      const annotList = annotationManager.getAnnotationsList();
      annotList.forEach(annot => {
        if (annot instanceof Annotations.PolygonAnnotation) {
          const points = annot.getPath();
          points.forEach(point => {
            // Work with points
          });
        }
      });
    });
  });
```

{% endcode %}

[PolygonAnnotation.getPath](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#getPath)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { docViewer, annotManager, Annotations } = instance;

    docViewer.addEventListener('annotationsLoaded', () => {
      const annotList = annotManager.getAnnotationsList();
      annotList.forEach(annot => {
        if (annot instanceof Annotations.PolygonAnnotation) {
          const points = annot.getPath();
          points.forEach(point => {
            // Work with points
          });
        }
      });
    });
  });
```

{% endcode %}

[PolygonAnnotation.getPath](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#getPath)
{% endtab %}
{% endtabs %}

### getPathPoint

If you know which point of the annotation path you would like to get, you can use [`getPathPoint`](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#getPathPoint) with the point index to retrieve the point.

### setPathPoint

Setting the path points on the polygon annotation can be done through [`setPathPoint`](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#setPathPoint). This can be used to initialize the points of the annotation if that was not done at the start.

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { documentViewer, annotationManager, Annotations } = instance.Core;

    documentViewer.addEventListener('annotationsLoaded', () => {
      const annotList = annotationManager.getAnnotationsList();
      annotList.forEach(annot => {
        if (annot instanceof Annotations.PolygonAnnotation) {
          annot.setPathPoint(0, 50, 100);
          annot.setPathPoint(1, 250, 150);
        }
      });
    });
  });
```

{% endcode %}

[PolygonAnnotation.setPathPoint](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#setPathPoint)
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
WebViewer(...)
  .then(instance => {
    const { docViewer, annotManager, Annotations } = instance;

    docViewer.addEventListener('annotationsLoaded', () => {
      const annotList = annotManager.getAnnotationsList();
      annotList.forEach(annot => {
        if (annot instanceof Annotations.PolygonAnnotation) {
          annot.setPathPoint(0, 50, 100);
          annot.setPathPoint(1, 250, 150);
        }
      });
    });
  });
```

{% endcode %}

[PolygonAnnotation.setPathPoint](https://sdk.apryse.com/api/web/Core.Annotations.PolygonAnnotation.html#setPathPoint)
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/annotation/annotation-types/polygonannotation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
